package require SOAP


proc ::SOAP::MIDAS_RegisterServer_Request {procVarName args} {
    upvar $procVarName procvar

    set params  $procvar(params)
    set name    $procvar(name)
    set uri     $procvar(uri)

#      puts "::SOAP::MIDAS_RegisterServer_Request called with $args"
#      foreach member [array names procvar] {puts "procvar($member) =  $procvar($member)"}
   
   set xml "<?xml version=\"1.0\"?>"
   append xml "<SOAP-ENV:Envelope xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\" "
   append xml "xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" "
   append xml "xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\" "
   append xml "xmlns:xsd=\"http://www.w3.org/1999/XMLSchema\" "
   append xml "SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">"

   append xml <SOAP-ENV:Body>
   append xml "<ns:$name xmlns:ns=\"$uri\">"

   set i 0; set j 0
   foreach arg $args {
       set ParamName [lindex $params $i]
       incr i
       set ParamType [lindex $params $i]
       incr i
       set ParamValue [lindex $args $j]
       incr j
       append xml "<$ParamName xsi:type=\"xsd:$ParamType\">$ParamValue</$ParamName>"
   }
   
   append xml "</ns:$name>"
   append xml </SOAP-ENV:Body>

   append xml </SOAP-ENV:Envelope>
      
   set xml [encoding convertto utf-8 $xml]          ;# make it UTF-8

#     puts "$xml"
#     puts ""
   
   return $xml
}

proc ::SOAP::MIDAS_RegisterServer_Reply {procVarName xml} {
    upvar $procVarName procvar

#      puts "::SOAP::MIDAS_RegisterServer_Reply called with $procVarName"
#      puts "$xml"
#      foreach member [array names procvar] {puts "procvar($member) =  $procvar($member)"}
#       puts ""

    if {$xml == {} && ![string match "http*" $procvar(proxy)]} {
        # This is probably not an error. SMTP and FTP won't return anything
        # HTTP should always return though (I think).
        return {}
    }

    set expected "<?xml version=\"1.0\"?>"
    if {[string compare -length 21 $xml $expected] == -1} {

#    unexpected reply or an error 

       return [::SOAP::parse_soap_response $procVarName $xml]
    }

#    This parser is VERY simple
#    Just look for the token <return and return whatever is the payload

#    Note - Using the Dom code to parse the XML  takes 10 ms

   set result ""
   set i 0

   set frags [split $xml >]
   foreach frag $frags {
       if {[string compare -length 7 $frag <return] == 0} {
           incr i
           set result "[lindex [split [lindex $frags $i] <] 0]"
           break
       }
       incr i
   }

    return $result
}



global SOAPServerHost SOAPServerPort
variable uri "urn:RegisterServer"
variable proxy "http://$SOAPServerHost:$SOAPServerPort/RegisterServer"

SOAP::create DefineServer -proxy $proxy -uri $uri -timeout 5000 -params {ServerName string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply

SOAP::create DefineRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string Class string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create InquireRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create WriteRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string Value string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create WriteRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string Value string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create ReadRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create ReadRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create InitialiseRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create InitialiseRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create WriteRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Register string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create WriteRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string Attributes string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create ReadRegisterAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create ReadRegistersAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create RegistersAttributes -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create DeleteRegister -proxy $proxy -uri $uri -timeout 5000 -params {Register string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 

SOAP::create DeleteRegisters -proxy $proxy -uri $uri -timeout 5000 -params {Pattern string} \
     -wrapProc  ::SOAP::MIDAS_RegisterServer_Request \
     -parseProc ::SOAP::MIDAS_RegisterServer_Reply 


