package require SOAP


proc ::SOAP::MIDAS_RshServer_Request {procVarName args} {
    upvar $procVarName procvar

    set params  $procvar(params)
    set name    $procvar(name)
    set uri     $procvar(uri)

#      puts "::SOAP::MIDAS_RshServer_Request called with $args"
#      foreach member [array names procvar] {puts "procvar($member) =  $procvar($member)"}
   
   set xml "<?xml version=\"1.0\"?>"
   append xml "<SOAP-ENV:Envelope xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\" "
   append xml "xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" "
   append xml "xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\" "
   append xml "xmlns:xsd=\"http://www.w3.org/1999/XMLSchema\" "
   append xml "SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">"

   append xml <SOAP-ENV:Body>
   append xml "<ns:$name xmlns:ns=\"$uri\">"

       set ParamName [lindex $params 0]
       set ParamType [lindex $params 1]
       set ParamValue $args

       append xml "<$ParamName xsi:type=\"xsd:$ParamType\">$ParamValue</$ParamName>"
   
   append xml "</ns:$name>"
   append xml </SOAP-ENV:Body>

   append xml </SOAP-ENV:Envelope>
      
   set xml [encoding convertto utf-8 $xml]          ;# make it UTF-8

#     puts "$xml"
#     puts ""
      
   return $xml
}

proc ::SOAP::MIDAS_RshServer_Reply {procVarName xml} {
    upvar $procVarName procvar

#      puts "::SOAP::MIDAS_RshServer_Reply called with $procVarName"
#      puts "$xml"
#      foreach member [array names procvar] {puts "procvar($member) =  $procvar($member)"}
#       puts ""

    if {$xml == {} && ![string match "http*" $procvar(proxy)]} {
        # This is probably not an error. SMTP and FTP won't return anything
        # HTTP should always return though (I think).
        return {}
    }

    set expected "<?xml version=\"1.0\"?>"
    if {[string compare -length 21 $xml $expected] == -1} {

#    unexpected reply or an error 

       return [::SOAP::parse_soap_response $procVarName $xml]
    }

#    This parser is VERY simple
#    Just look for the token <return and return whatever is the payload

#    Note - Using the Dom code to parse the XML  takes 10 ms

   set result ""
   set i 0

   set frags [split $xml >]
   foreach frag $frags {
       if {[string compare -length 7 $frag <return] == 0} {
           incr i
           set result "[lindex [split [lindex $frags $i] <] 0]"
           break
       }
       incr i
   }

    return $result
}


global SOAPServerHost SOAPServerPort
variable uri "urn:RshServer"
variable proxy "http://$SOAPServerHost:$SOAPServerPort/RshServer"

SOAP::create Rsh -proxy $proxy -uri $uri -params {p string} \
     -wrapProc  ::SOAP::MIDAS_RshServer_Request \
     -parseProc ::SOAP::MIDAS_RshServer_Reply 

