
# Load the SOAP service support framework
package require SOAP::Domain

global MIDAS_SOAPService_RegisterServer   MIDAS_SOAPService_Verbose
set MIDAS_SOAPService_RegisterServer "/Undefined"
set MIDAS_SOAPService_Verbose 0

# Use namespaces to isolate your methods
namespace eval urn:RegisterServer {

    proc SetRegisterServerVerbose {p} {
        global MIDAS_SOAPService_RegisterServer   MIDAS_SOAPService_Verbose
        set MIDAS_SOAPService_Verbose $p
        set status $p
        return [rpcvar::rpcvar string $status]
    }

    proc DefineServer {p} {
        global MIDAS_SOAPService_RegisterServer   MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method DefineServer with parameter $p"}
        set MIDAS_SOAPService_RegisterServer $p
        set status "$MIDAS_SOAPService_RegisterServer"
        return [rpcvar::rpcvar string $status]
    }

    proc InquireRegisters {p} {
        global MIDAS_SOAPService_RegisterServer   MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method InquireRegisters with parameter $p"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :pattern '$p' ?names)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc WriteRegister {r v} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method WriteRegister with parameters $r $v"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :name '$r' :value '$v')"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc WriteRegisters {p v} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method WriteRegisters with parameters $p $v"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :pattern '$p' :value '$v')"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc ReadRegister {r} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method ReadRegister with parameter $r"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :name '$r' ?value)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc ReadRegisters {p} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method ReadRegisters with parameter $p"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :pattern '$p' ?names-and-values)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc InitialiseRegister {r} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method InitialiseRegister with parameter $r"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :name '$r' !initialise)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc InitialiseRegisters {p} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method InitialiseRegisters with parameter $p"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :pattern '$p' !initialise)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc WriteRegisterAttributes {r a} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method WriteRegisterAttributes with parameters $r $a"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :name '$r' :object '$a')"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc WriteRegistersAttributes {p a} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method WriteRegistersAttributes with parameters $p $a"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :pattern '$p' :object '$a')"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc ReadRegisterAttributes {r} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method ReadRegisterAttributes with parameter $r"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :name '$r' ?object)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc ReadRegistersAttributes {p} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method ReadRegistersAttributes with parameter $p"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :pattern '$p' ?names-and-objects)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc DefineRegister {r c a} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method DefineRegister with parameters $r $c $a"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :name '$r' !delete)"} m]
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :name '$r' :class '$c' !new)"} m]
        if {!$z} {set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :name '$r' :object '$a')"} m]}
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc DeleteRegister {r} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method DeleteRegister with parameter $r"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :name '$r' !delete)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }

    proc DeleteRegisters {p} {
        global MIDAS_SOAPService_RegisterServer MIDAS_SOAPService_Verbose
        if {$MIDAS_SOAPService_Verbose} {puts "called method DeleteRegisters with parameter $p"}
        set z [catch {eg "(register :path '/$MIDAS_SOAPService_RegisterServer' :pattern '$p' !delete)"} m]
        set status "$m"
        return [rpcvar::rpcvar string $status]
    }



    # We have to publish the public methods...

     SOAP::export SetRegisterServerVerbose
     SOAP::export DefineServer
     SOAP::export DefineRegister
     SOAP::export InquireRegisters
     SOAP::export WriteRegister
     SOAP::export WriteRegisters
     SOAP::export ReadRegister
     SOAP::export ReadRegisters
     SOAP::export InitialiseRegister
     SOAP::export InitialiseRegisters
     SOAP::export WriteRegisterAttributes
     SOAP::export ReadRegisterAttributes
     SOAP::export WriteRegistersAttributes
     SOAP::export ReadRegistersAttributes
     SOAP::export DeleteRegister
     SOAP::export DeleteRegisters


}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /RegisterServer -namespace urn:RegisterServer -uri urn:RegisterServer]


global MIDAS_SOAPDomainHandler_Debug
set MIDAS_SOAPDomainHandler_Debug 0

proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/RegisterServer {optsname sock args} {
    global MIDAS_SOAPDomainHandler_Debug
    variable debug
    upvar \#0 Httpd$sock data
    upvar \#0 $optsname options

  if {$MIDAS_SOAPDomainHandler_Debug} {
      puts "::SOAP::Domain::MIDAS_SOAPDomainHandler_/RegisterServer called with $optsname || $sock || $args"
      foreach member [array names options] {puts "options($member) =  $options($member)"}
      foreach member [array names data] {puts "data($member) =  $data($member)"}
      puts ""
  }

    # if suffix is {} then it fails to make it through the various evals.
    set suffix [lindex $args 0]
    
    # check this is an XML post
    set failed [catch {set type $data(mime,content-type)} msg]
    if { $failed } {
        set msg "Invalid SOAP request: not XML data"
        log::log debug $msg
        Httpd_ReturnData $sock text/xml [SOAP::fault SOAP-ENV:Client $msg] 500
        return $failed
    }
    
    # make sure we were sent some XML
    set failed [catch {set query $data(query)} msg]
    if { $failed } {
        set msg "Invalid SOAP request: no data sent"
        log::log debug $msg
        Httpd_ReturnData $sock text/xml [SOAP::fault SOAP-ENV:Client $msg] 500
        return $failed
    }

    # Check that we have a properly registered domain
    if { ! [info exists options] } {
        set msg "Internal server error: domain improperly registered"
        log::log debug $msg
        Httpd_ReturnData $sock text/xml [SOAP::fault SOAP-ENV:Server $msg] 500
        return 1
    }   

   set argValues {}

   set frags [split $data(query) >]
   set fragNum [llength $frags]

   for {set i 0} {$i < $fragNum} {incr i} {
       set frag [lindex $frags $i]
       if {[string compare -length 14 $frag <SOAP-ENV:Body] == 0} {
            incr i
            set frag [lindex $frags $i]
            set methodName [string range [lindex [split $frag " "] 0] 4 end]
            incr i
            for {} {$i < $fragNum} {incr i} {
                set frag [lindex $frags $i]
                if {[string compare -length 3 $frag </ns] == 0} {break}
                    incr i
                    set frag [lindex $frags $i]
                    lappend argValues [lindex [split $frag <] 0]
            }
       }
   }

       # evaluate the method
       set z [catch {interp eval "" ::namespace inscope $options(-namespace) $methodName $argValues} msg]

    if {$z == 0}  {

       set xml "<?xml version=\"1.0\"?>"
       append xml "<SOAP-ENV:Envelope xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\" "
       append xml "xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" "
       append xml "xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\" "
       append xml "xmlns:xsd=\"http://www.w3.org/1999/XMLSchema\">"

       append xml "<SOAP-ENV:Body>"

       append xml "<ns:[set methodName]Response xmlns:ns=\"\" SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">"
       append xml "<return xsi:type=\"xsd:[lindex $msg 4]\">[lindex $msg 5]</return>"
       append xml "</ns:[set methodName]Response>"

       append xml "</SOAP-ENV:Body>"

       append xml "</SOAP-ENV:Envelope>"

       set xml [encoding convertto utf-8 $xml]          ;# make it UTF-8

    Httpd_ReturnData $sock text/xml $xml [expr {$failed ? 500 : 200}]

       set failed 0

    } else {
 
       set failed 1
    }

    return $failed
}

# -------------------------------------------------------------------------
